/* AddEvent Macro
    Adds events to calendars created by my
    Calendar Macro for FinalWriter4 (SoftWood)
    Written by Ronald Goertz
    $VER: AddEvent v1.2 (11 Mar 96)
 */
 
 OPTIONS RESULTS
 
/* User-defined variables */
Font             = "SoftSans"
FSize            = 8
FWidth           = 100
 
/* Program variables */
GetPageSetup Width Height Top Bottom Left Right
parse var result FullWidth FullHeight TopMargin BottomMargin LeftMargin RightMargin

GetDisplayPrefs Measure; Units = result
select
   when Units = 'Inches' then PointsPerUnit = 72
   when Units = 'Metric' then PointsPerUnit = 28.34645669291
   when Units = 'Pica' then   PointsPerUnit = 12
end

FHeight    = FSize / PointsPerUnit
TextOffset = 3.6 / PointsPerUnit

PageWidth  = FullWidth - LeftMargin - RightMargin
PageHeight = FullHeight - TopMargin - BottomMargin
TextArea   = .15 * PageHeight
BoxWidth   = PageWidth/7
BoxHeight  = (PageHeight-TextArea)/5
 
MonthLength.1    = 31
MonthLength.2    = 28
MonthLength.3    = 31
MonthLength.4    = 30
MonthLength.5    = 31
MonthLength.6    = 30
MonthLength.7    = 31
MonthLength.8    = 31
MonthLength.9    = 30
MonthLength.10   = 31
MonthLength.11   = 30
MonthLength.12   = 31
 
TextBlockTypePrefs SIZE FSize WIDTH FWidth COLOR Black FONT font
BoxPrefs LINEWT Hairline FILL Solid FILLCOLOR White
 
GetTextBlockText 2
TempDate = RESULT
SelectObject
 
Month = substr(TempDate,5,2)
if left(Month,1) == "0" then Month = right(Month,1)
PrevMonth = Month - 1
if PrevMonth = 0 then PrevMonth = 12
 
Year = left(TempDate,4)
if (Year//4 == 0 & Year//100 > 0) | Year//400 == 0 Then MonthLength.2  = 29
 
StartDate = date('w',TempDate,'S')
Select
   When StartDate == "Sunday"    Then StartDate = 0
   When StartDate == "Monday"    Then StartDate = 1
   When StartDate == "Tuesday"   Then StartDate = 2
   When StartDate == "Wednesday" Then StartDate = 3
   When StartDate == "Thursday"  Then StartDate = 4
   When StartDate == "Friday"    Then StartDate = 5
   When StartDate == "Saturday"  Then StartDate = 6
End
 
Do While 1
   Drop RESULT
   RequestText '"Event Entry" "Enter event as: Day,Day,Line,Box,Event" ""'
   input = RESULT
   if input == "RESULT" | input == "" then Exit
   Parse Var input Day1 ',' Day2 ',' Line ',' Box ',' Event
 
   Box = left(upper(Box),1)
   if Box == 'B' | pos('//',Event) ~= 0 then Box = 'Y'

   If Day2 == "DAY2" | Day2 == "" then Day2 = Day1
 
   If upper(left(Day1,1)) == "P" then Day1 = substr(Day1,2) - MonthLength.PrevMonth
   If upper(left(Day2,1)) == "P" then Day2 = substr(Day2,2) - MonthLength.PrevMonth
   If upper(left(Day1,1)) == "N" then Day1 = substr(Day1,2) + MonthLength.Month
   If upper(left(Day2,1)) == "N" then Day2 = substr(Day2,2) + MonthLength.Month
 
   If Day1 > Day2 then Do
      TempDate = Day1
      Day1 = Day2
      Day2 = TempDate
   End
   If Day1 ~= Day2 then Box = 'Y'

   If Day1 <= -StartDate then Do
      ShowMessage 1 0 '"Dates cannot come before" "the beginning of the calendar." "" "OK" "" ""'
      Exit
   End
 
   if ((StartDate + MonthLength.Month > 35) & (Day2 > MonthLength.Month)) | ((StartDate + MonthLength.Month < 36) & (Day2 > 35 - StartDate)) then do
      ShowMessage 1 0 '"Dates cannot come after" "the end of the calendar." "" "OK" "" ""'
      Exit
   End
 
   Day1Row = trunc((Day1 + StartDate - 1)/7)
   Day2Row = trunc((Day2 + StartDate - 1)/7)
   Day1Column = (Day1 + StartDate) - 7*Day1Row - 1
   LeftEdge = LeftMargin + Day1Column*BoxWidth + TextOffset
   If Day1Row < 5 then PrintRow = Day1Row * BoxHeight
   else PrintRow = trunc(4.5 * BoxHeight)
    
   If Box ~= 'Y' then do /* Single day, unboxed event */
      Textline = 1
      event2 = ''
      Do until event == ''
         TextBottom = TopMargin + TextArea + PrintRow + (Line+1)*FHeight*1.1
         TextLeft   = LeftMargin + Day1Column*BoxWidth + TextOffset*Textline
         DrawTextBlock 1 TextLeft TextBottom Event; obj = result
         redraw
         GetObjectCoords obj; coords = result
         parse var coords Pg . . TextWidth .
         If length(event) > 34 then TextWidth = 2*BoxWidth
         if (TextWidth + Textline*TextOffset >= BoxWidth) & (Words(event) > 1)then do
            posn = lastpos(' ', event)
            event2 = strip(substr(event, posn)' 'event2)
            event  = strip(left(event, posn))
            DeleteObject obj
         end
         else if event2 ~= '' then do
            Textline = 3
            Line = Line + 1
            event = event2
            event2 = ''
         end
         else event = ''
      End
   end
   else do until Day1Row > Day2Row /* multi-day boxed events*/
      SearchPos = 1
      Found = 1
      TextRows = 1
      do until Found = 0
         Found = pos('//',Event,SearchPos)
         if Found > 0 then do
            Text.TextRows = substr(Event,SearchPos,Found - SearchPos)
            SearchPos = Found + 2
            TextRows = TextRows + 1
         end
         else Text.TextRows = substr(Event,SearchPos)
         end

         if Day2Row > Day1Row then Width = (LeftMargin + 7*BoxWidth) - LeftEdge
         else Do
            Day2Column = (Day2 + StartDate) - 7*Day2Row - 1
            Width = (LeftMargin + (Day2Column + 1)*BoxWidth - TextOffset) - LeftEdge
         End
 
         TopEdge = TopMargin + TextArea + PrintRow + Line*FHeight + (FHeight * .4)
         DrawBox 1 LeftEdge TopEdge Width FHeight*TextRows
 
         do i = 1 to TextRows
            TextBottom = TopMargin + TextArea + PrintRow + (Line+i)*FHeight*1.1
            DrawTextBlock 1 1 TextBottom Text.i
            ID = RESULT
            GetObjectCoords ID
            parse var result . . . TextWidth TextHeight
            TextLeft = LeftEdge + (Width - TextWidth)/2
            SetObjectCoords ID 1 TextLeft TextBottom TextWidth TextHeight
         end

         Day1Row = Day1Row + 1
         If Day1Row < 5 then PrintRow = Day1Row * BoxHeight
         else PrintRow = trunc(4.5 * BoxHeight)
         LeftEdge = LeftMargin - 1
      End
   Redraw
   SelectObject
End
